<?php
/**
 * @version		$Id$
 * @package		Google Tracking
 * @subpackage	Module
 * @author		Michal Unzeitig, ARTIO s.r.o.
 * @copyright	Copyright (C) 2009 ARTIO s.r.o., All rights reserved.
 * @license		GNU/GPL
 */
// security check
defined('_JEXEC') or die('Restricted access');

class plgSystemGACode extends JPlugin
{
  // the Google Analytics scripts
  private $script1 = 
  "	var gaJsHost = ((\"https:\" == document.location.protocol) ? \"https://ssl.\" : \"http://www.\");
  document.write(unescape(\"%3Cscript src='\" + gaJsHost + \"google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E\"));";
  private $script2 = 
  '	try {
    var pageTracker = _gat._getTracker("%s");
    pageTracker._trackPageview();%s
  } catch(err) {}
  ';
  
  private $uaCode;
  private $trackVM;
  private $vmCode;
    
  function plgSystemGACode( &$subject, $config ) {
    parent::__construct($subject, $config);
    
    // fetch plugin parameters
    $this->uaCode  = $this->params->get('uaCode', '');
    $this->trackVM = $this->params->get('trackVM', '');		
  }

  // It's easier to put the script just before the </body> by using this trigger
  function onAfterRender() {
    // do not run in admin
    global $mainframe;
    
    // we don't want to track admin
    if ($mainframe->isAdmin()) return;

    // get orders info if trackvm
    $this->vmCode  = $this->trackVM ? $this->getVMTrackCode() : '';  

    // output general code
    $document = & JFactory::getDocument();

    // Creation of the script block with the content of variables (the uacode and the Virtuemart part)
    $script_tracking = '<script type="text/javascript">
    <!--
    '.$this->script1.'
    -->
    </script>
    <script type="text/javascript">
    <!--
    '.sprintf($this->script2, $this->uaCode, $this->vmCode)
    .'-->
    </script>
    ';

    // We fetch the generated page (that's why we use the trigger onAfterRender)
    $app =& JFactory::getApplication();
    $body = JResponse::getBody();

    // So we can add the Google analytics scripts just before </body>
    $body = str_replace('</body>', $script_tracking . '</body>', $body );
    // and then replace the old body in JResponse
    JResponse::setBody($body);
  }
	
	// Le't get information of the current order
  function getVMTrackCode() {
    // we want to know where we are
    $option = JRequest::getVar('option');
    $page = JRequest::getVar('page');

    // if we're not on the page checkout.thankyou of Virtuemart, we can exit
    if ($option != 'com_virtuemart' || $page != 'checkout.thankyou') return '';
    
    require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_virtuemart'.DS.'classes'.DS.'ps_database.php');
	
    $db = new ps_DB;
    $order_id = $db->getEscaped($GLOBALS['vars']['order_id']);

    $q = 'SELECT order_id, order_total, order_tax, order_shipping, city, state, country'
    . ' FROM #__{vm}_orders'
    . ' LEFT JOIN #__{vm}_order_user_info USING (order_id)'	
    . ' WHERE order_id = ' . $order_id;			

    $db->query($q);

		$db->next_record();
		
    $code = sprintf('pageTracker._addTrans("%d", "", "%f", "%s", "%f", "%s", "%s", "%s");',
    $db->f('order_id'), $db->f('order_total'), $db->f('order_tax'),
    $db->f('order_shipping'), $db->f('city'), $db->f('state'), $db->f('country'));

    $q = 'SELECT order_id, order_item_sku, order_item_name, GROUP_CONCAT(category_name SEPARATOR \', \') AS categories, product_final_price, product_quantity'
    . ' FROM #__{vm}_order_item LEFT JOIN #__{vm}_product_category_xref USING (product_id)'
    . ' LEFT JOIN #__{vm}_category AS c USING (category_id)'
    . ' WHERE order_id = ' . $order_id
    . ' GROUP BY order_id, order_item_sku, order_item_name, product_final_price, product_quantity';

    $db->query($q);	
		
    while ($db->next_record()) {
      $code .= sprintf(' pageTracker._addItem("%d", "%s", "%s", "%s", "%f", "%f");',
      $db->f('order_id'), $db->f('order_item_sku'), $db->f('order_item_name'),
      $db->f('categories'), $db->f('product_final_price'), $db->f('product_quantity'));
    }

    $code .= ' pageTracker._trackTrans();';

    return $code;
  }
}
?>
